#pragma once
#include "Observer.h"
#include <vector>

class Subject
{
    protected:
        std::vector<Observer*> _observers;

    public:
        
        virtual void attach(Observer* observer) = 0;
        virtual void detach(Observer* observer) = 0;
        virtual void notify() = 0;
};